screen:clear()

charset1 = {",","a","b","c",".","d","e","f","!","g","h","i","-","j","k","l","","m",
	    " ","n","?","o","p","q","(","r","s","t",":","u","v","w",")","x","y","z"}

charset2 = {",","(",".",")","\"","<","'",">","-","[","_","]","!","{","?","}",""," ",
	    " "," ","+","\\","=","/",":","@",";","#","~","$","`","%","*","^","|","&"}

charset3 = {"1","1","1","1","2","2","2","2","3","3","3","3","4","4","4","4","","5",
	    " ","5","6","6","6","6","7","7","7","7","8","8","8","8","9","9","0","0"}

case = 0
pad = 1
lstsel = 1
act_sel = 1
skin_num = 1
selected = 1
line_inc = 10
currently_playing = 0

status = "idle"
setup_status = "idle"

word = ""
append = ""
setup_append = ""

charset_cur = charset1
charset_cur_index = 1

controls = Controls.read()
stillX =  controls:analogX()
stillY = controls:analogY()

fields = {}
values = {}
setup_fields = {}
setup_values = {}

usrlog = {}
msglog = {}
usronl = {}
newmsg = {}
usrblc = {}
log_data = {}

new_online = Sound.load("sounds/online.wav")
new_message = Sound.load("sounds/newmsg.wav")
send_message = Sound.load("sounds/sendmsg.wav")

white = Color.new(255, 255, 255)
black = Color.new(0, 0, 0)

counter = Timer.new()
counter:start()

function getletter(sensitivity,charset_cur,x_orig,y_orig,controls)
	local out = {}
	out[3] = false

	AnaX = controls:analogX()
	AnaY = controls:analogY()

	if AnaX > stillX + sensitivity then
		direction = "right"
	elseif AnaX < stillX - sensitivity then
		direction = "left"
	else
		direction = "middle"
	end

	if AnaY > stillY + sensitivity then
		direction2 = "bottom"
	elseif AnaY < stillY - sensitivity then
		direction2 = "top"	
	else
		direction2 = "middle"
	end

	direction_full = direction2..direction
	out[4] = direction_full

	if direction_full == "topleft" then
		out[1] = x_orig-5
		out[2] = y_orig
		if controls:triangle() then
			out[3] = charset_cur[1]
		elseif controls:square() then
			out[3] = charset_cur[2]
		elseif controls:cross() then
			out[3] = charset_cur[3]
		elseif controls:circle() then
			out[3] = charset_cur[4]
		end
	elseif direction_full == "topmiddle" then
		out[1] = x_orig+30
		out[2] = y_orig
		if controls:triangle() then
			out[3] = charset_cur[5]
		elseif controls:square() then
			out[3] = charset_cur[6]
		elseif controls:cross() then
			out[3] = charset_cur[7]
		elseif controls:circle() then
			out[3] = charset_cur[8]
		end
	elseif direction_full == "topright" then
		out[1] = x_orig+65
		out[2] = y_orig
		if controls:triangle() then
			out[3] = charset_cur[9]
		elseif controls:square() then
			out[3] = charset_cur[10]
		elseif controls:cross() then
			out[3] = charset_cur[11]
		elseif controls:circle() then
			out[3] = charset_cur[12]
		end
	elseif direction_full == "middleleft" then
		out[1] = x_orig-5
		out[2] = y_orig+34
		if controls:triangle() then
			out[3] = charset_cur[13]
		elseif controls:square() then
			out[3] = charset_cur[14]
		elseif controls:cross() then
			out[3] = charset_cur[15]
		elseif controls:circle() then
			out[3] = charset_cur[16]
		end
	elseif direction_full == "middlemiddle" then
		out[1] = x_orig+30
		out[2] = y_orig+34
		if controls:triangle() then
			out[3] = charset_cur[17]
		elseif controls:square() then
			out[3] = charset_cur[18]
		elseif controls:cross() then
			out[3] = charset_cur[19]
		elseif controls:circle() then
			out[3] = charset_cur[20]
		end
	elseif direction_full == "middleright" then
		out[1] = x_orig+65
		out[2] = y_orig+34
		if controls:triangle() then
			out[3] = charset_cur[21]
		elseif controls:square() then
			out[3] = charset_cur[22]
		elseif controls:cross() then
			out[3] = charset_cur[23]
		elseif controls:circle() then
			out[3] = charset_cur[24]
		end
	elseif direction_full == "bottomleft" then
		out[1] = x_orig-5
		out[2] = y_orig+68
		if controls:triangle() then
			out[3] = charset_cur[25]
		elseif controls:square() then
			out[3] = charset_cur[26]
		elseif controls:cross() then
			out[3] = charset_cur[27]
		elseif controls:circle() then
			out[3] = charset_cur[28]
		end
	elseif direction_full == "bottommiddle" then
		out[1] = x_orig+30
		out[2] = y_orig+68
		if controls:triangle() then
			out[3] = charset_cur[29]
		elseif controls:square() then
			out[3] = charset_cur[30]
		elseif controls:cross() then
			out[3] = charset_cur[31]
		elseif controls:circle() then
			out[3] = charset_cur[32]
		end
	elseif direction_full == "bottomright" then
		out[1] = x_orig+65
		out[2] = y_orig+68
		if controls:triangle() then
			out[3] = charset_cur[33]
		elseif controls:square() then
			out[3] = charset_cur[34]
		elseif controls:cross() then
			out[3] = charset_cur[35]
		elseif controls:circle() then
			out[3] = charset_cur[36]
		end
	end
	return out
end

function explode(str,div)
	if str == nil then return "" end
	if (div=='') then return "" end
	local pos,arr = 0,{}
		for st,sp in function() return string.find(str,div,pos,true) end do
			table.insert(arr,string.sub(str,pos,st-1)) -- Attach chars left of current divider
			pos = sp + 1 -- Jump past current divider
		end
	table.insert(arr,string.sub(str,pos)) -- Attach chars right of last divider
	return arr
end

function GetBetween(str, find1, find2)
	local parts = explode(str, find1)
	local parts2 = explode(parts[2], find2)
	return parts2[1]
end

function writefile(iofile,text)
	if string.len(text) > 0 then
		file = io.open(iofile, "a")
		if file then
			file:write(text)
			file:close()
		end
	end
end

function fileexists(iofile)
	local exists = false
	local file = io.open(iofile, "r")
	if file then
		exists = true
		file:close()
	end
	return exists
end

function getMusic()
	local files = System.listDirectory(music_dir)
	local mp3 = {}

	for i=1,#files do
		if string.find(files[i].name,".mp3",1,true) then
			table.insert(mp3,files[i].name)
		end
	end
	return mp3
end

function playFile(file)
	if file then
		if mp3_high_cpu == 1 then
			System.setHigh()
		end

		if is_playing then
			Mp3.stop()
		end

		Mp3.load(music_dir..file)
		Mp3.play()

		is_playing = true

		status = "NP: "..file
	end
end

function nextTrack()
	if mp3_files[currently_playing+1] then
		playFile(mp3_files[currently_playing+1])
		currently_playing = currently_playing+1
	elseif mp3_files[1] then
		playFile(mp3_files[1])
		currently_playing = 1
	end
end

function prevTrack()
	if mp3_files[currently_playing-1] then
		playFile(mp3_files[currently_playing-1])
		currently_playing = currently_playing-1
	end
end

function stopPlay()
	if is_playing then
		Mp3.stop()
		System.setReg()
		is_playing = false
	else
		playFile(mp3_files[currently_playing])
		is_playing = true
	end
end

function setSkin(number)
	local skin = {}
	local number = tostring(number)
	local skin_location = "skins/"..number.."/skin.cfg"
	if not fileexists(skin_location) then
		skin_location = "skins/1/skin.cfg"
		number = 1
	end
	for line in io.lines(skin_location) do
		if string.sub(line,0,1) ~= "#" then
			local skin_val = GetBetween(line,"=","\r\n")
			skin_val = string.gsub(skin_val, "\r", "")
			skin_val = string.gsub(skin_val, "\n", "")
			table.insert(skin, skin_val)
		end
	end

	for i=1,#skin do
		if string.find(skin[i],",",1,true) then
			local rgb = explode(skin[i], ",")
			skin[i] = Color.new(rgb[1], rgb[2], rgb[3])
		elseif string.find(skin[i],":",1,true) then
			skin[i] = string.gsub(skin[i], ":", "",1)
		else
			skin[i] = tonumber(skin[i])
		end
	end

	show_borders = tonumber(skin[1])
	background_color = skin[3]
	textbox_font_color = skin[4]
	user_selected = skin[5]
	user_new_message = skin[6]
	user_away = skin[7]
	user_away_selected = skin[8]
	user_away_blocked = skin[9]
	user_blocked = skin[10]
	user_blocked_selected = skin[11]
	user_online = skin[12]
	user_log = skin[13]
	new_message_text = skin[14]
	action_menu_bgcolor = skin[15]
	action_menu_fontclr = skin[16]
	keypad_selected_color = skin[17]
	keypad_background_color = skin[18]
	keypad_letter_color = skin[19]
	border_color = skin[20]
	main_font_color = skin[21]
	main_selected_color = skin[22]
	list_x_position = skin[23]
	list_y_position = skin[24]
	list_max_chars = skin[25]
	list_max_lines = skin[26]
	log_x_position = skin[27]
	log_y_position = skin[28]
	log_max_chars = skin[29]
	log_max_lines = skin[30]
	textbox_x_position = skin[31]
	textbox_y_position = skin[32]
	textbox_max_chars = skin[33]
	new_message_alert_x = skin[34]
	new_message_alert_y = skin[35]
	new_message_alert_text = skin[36]
	keypad_location_x = skin[37]
	keypad_location_y = skin[38]
	keypad_show_bg = skin[39]
	status_location_x = skin[40]
	status_location_y = skin[41]
	status_max_length = skin[42]
	menu_location_x = skin[43]
	menu_location_y = skin[44]
	user_encapsulation = skin[45]
	my_screenname_color = skin[46]
	ur_screenname_color = skin[47]
	if tonumber(skin[2]) > 0 then
		background_image = Image.load("skins/"..number.."/pspbg.png")
	end

	color = Image.createEmpty(32, 31)
	color:clear(keypad_selected_color)

	blk = Image.createEmpty(103, 96)
	blk:clear(keypad_background_color)

	blax = Image.createEmpty(110, 110)
	blax:clear(black)

	menu = Image.createEmpty(120, 60)
	menu:clear(action_menu_bgcolor)
end

function setPrefs()
	local prefs = {}

	for line in io.lines("prefs.cfg") do
		if string.sub(line,0,1) ~= "#" then
			local pref_value = GetBetween(line,"=","\r\n")
			if string.find(pref_value, "/") then
				table.insert(prefs, pref_value)
			else
				table.insert(prefs, tonumber(pref_value))
			end
		end
	end

	log_chats = prefs[1]
	play_sounds = prefs[2]
	sensitivity = prefs[3]
	key_timeout = prefs[4]
	default_skin = prefs[5]
	mp3_high_cpu = prefs[6]
	music_dir = prefs[7]
end

function saveChat(message,usertolog)
	file = io.open("logs/"..usertolog..".txt", "a")
	if file then
		file:write(message.."\r\n")
		file:close()
	else
		file2 = io.open("logs/"..usertolog..".txt", "w")
		if file2 then
			file2:write(message.."\r\n")
		end
		file2:close()
	end
end

function highlite(pad,keypad_location_x,keypad_location_y,color)
	if pad == 1 then
		screen:blit(keypad_location_x,keypad_location_y,color)
	end
end

function createfield(x,y,length,fieldz,valuez)
	table.insert(fieldz, x..":"..y..":"..length..":0")
	table.insert(valuez, "")
	return fieldz
end

function wordWrap(array,line,chars)
	line = string.gsub(line, "  ", " ")
	if string.len(line) > chars then
		local tempstr = ""
		wrap = explode(line, " ")
		for i=1,#wrap do
		if string.len(tempstr..wrap[i]) <= chars then
			tempstr = tempstr .. wrap[i] .. " "
		else
			table.insert(array, tempstr)
			if string.len(wrap[i]) > chars then
			toolong = wrap[i]
			while string.len(toolong) > chars do
				table.insert(array, string.sub(toolong,0,chars))
				toolong = string.sub(toolong,chars+1,string.len(toolong))
			end
			tempstr = toolong .. " "
			else
			tempstr = wrap[i] .. " "
			end
		end
		end

		if string.len(tempstr) > 0 then
		table.insert(array, tempstr)
		end
	else
		table.insert(array, line)
	end

	return array
end

function showlog(x,y,chars,linesnum,lines,convo)
	local log = {}
	local start = 0
	local chars = chars-1
	local truncate = {}

	if #lines > linesnum then
		for i=#lines-linesnum,#lines do
			log = wordWrap(log,lines[i],chars)
			table.insert(truncate, lines[i])
		end
	else
		for i=1,#lines do
			log = wordWrap(log,lines[i],chars)
		end
		truncate = lines
	end

	local sub = #log-linesnum
	if sub < 1 then
		sub = 1
	end

	for i=1,linesnum do
		if convo == 1 then
			you_find = string.gsub(user_encapsulation,"$u",config[1])
			them_find = string.gsub(user_encapsulation,"$u",usrlog[lstsel])
		end
		curline = log[i+sub]
		if curline then
			screen:print(x+4,(y+3)+start*10, curline, user_log)
			if convo == 1 then
				check_you = string.sub(curline,0,string.len(you_find))
				check_them = string.sub(curline,0,string.len(them_find))
				if check_you == you_find then
					screen:print(x+4,(y+3)+start*10, you_find, my_screenname_color)
				elseif check_them == them_find then
					screen:print(x+4,(y+3)+start*10, them_find, ur_screenname_color)
				end
			end
			start = start + 1
		else
			break
		end
	end

	if show_borders > 0 then
		screen:drawLine(x, y, x+chars*8, y, border_color)
		screen:drawLine(x, y, x, y+linesnum*10+3, border_color)
		screen:drawLine(x+chars*8, y, x+chars*8, y+linesnum*10+3, border_color)
		screen:drawLine(x, y+linesnum*10+3, x+chars*8, y+linesnum*10+3, border_color)
	end

	--screen:print(10,10,#truncate,white)

	return truncate
end

function showlist(x,y,chars,linesnum,data,selected,highlite)
	local log = {}
	local start = 0
	local chars = chars-1
	local log = data
	local sub = #log-linesnum
	local offset = 0
	local out = ""
	log = data

	if selected > linesnum then
		offset = selected - linesnum
	end

	for i=1+offset,linesnum+offset do
		curline = log[i]
		if curline then
			if selected == i then
				if inarray(usrblc,curline) then
					screen:print(x+4,(y+3)+start*10, curline, user_blocked_selected)
				elseif not inarray(usronl,curline) then
					screen:print(x+4,(y+3)+start*10, curline, user_away_selected)
				else
					screen:print(x+4,(y+3)+start*10, curline, user_selected)
				end
			else
				if inarray(newmsg,curline) then
					screen:print(x+4,(y+3)+start*10, curline, user_new_message)
				else
					if inarray(usrblc,curline) then
						screen:print(x+4,(y+3)+start*10, curline, user_blocked)
					elseif inarray(usronl,curline) then
						screen:print(x+4,(y+3)+start*10, curline, user_online)
					else
						screen:print(x+4,(y+3)+start*10, curline, user_away)
					end
				end
			end	
			
			start = start + 1
		else
			break
		end
		out = out .. log[i] .."\r\n"
	end

	if show_borders > 0 then
		screen:drawLine(x, y, x+chars*8, y, border_color)
		screen:drawLine(x, y, x, y+linesnum*10+3, border_color)
		screen:drawLine(x+chars*8, y, x+chars*8, y+linesnum*10+3, border_color)
	end

	if highlite then
		screen:drawLine(x, y+linesnum*10+3, x+chars*8, y+linesnum*10+3, white)
	end
	return out
end

function adduser(usrlog,user)
	num = false
	for i=1,#usrlog do
		if usrlog[i] == user then
			num = true
			break
		end
	end

	if not num then
		table.insert(usrlog, user)
		msglog[#usrlog] = {}
		table.insert(msglog[#usrlog], '')
	end

	return usrlog
end

function deluser(usrlog,user)
	num = false
	for i=1,#usrlog do
		if usrlog[i] == user then
			table.remove(usrlog,i)
			table.remove(msglog,i)
			break
		end
	end
	return usrlog
end

function addtoarray(array,string)
	local exists = false
	for i=1,#array do
		if array[i] == string then
			exists = true
			break
		end
	end

	if not exists then
		table.insert(array, string)
	end
	return array
end

function inarray(array,string)
	local exists = false
	for i=1,#array do
		if array[i] == string then
			exists = true
			break
		end
	end
	return exists
end

function getindex(array,string)
	local num = false
	for i=1,#array do
		if array[i] == string then
			num = i
			break
		end
	end
	return num
end

function changeuser(array,fuser,nuser)
	for i=1,#array do
		if array[i] == fuser then
			array[i] = nuser
			break
		end
	end
	return array
end

function delfromarray(array,string)
	local exists = false
	for i=1,#array do
		if array[i] == string then
			table.remove(array, i)
		end
	end
	return array
end

function logs_add(usrlog,msglog,user,message)
	num = false
	for i=1,#usrlog do
		if usrlog[i] == user then
			num = i
			break
		end
	end

	if num then
		table.insert(msglog[num], message)
	else
		table.insert(usrlog, user)
		msglog[#usrlog] = {}
		table.insert(msglog[#msglog], message)
	end

end

function showfields(valuez, fieldz, selected, fontcolor)
	for i = 1,#fieldz do
		local vals = explode(fieldz[i], ":")

		if show_borders > 0 then
			screen:drawLine(vals[1], vals[2], vals[1]+vals[3]*8, vals[2], border_color)
			screen:drawLine(vals[1]+vals[3]*8, vals[2], vals[1]+vals[3]*8, vals[2]+15, border_color)
			screen:drawLine(vals[1], vals[2], vals[1], vals[2]+15, border_color)
		end

		if i == selected then
			screen:drawLine(vals[1], vals[2]+15, vals[1]+vals[3]*8, vals[2]+15, white)
		end

		start = vals[4]
		fin = vals[4] + vals[3]
		if start ~= "0" then fin = fin - 1 end
		if fin > string.len(valuez[i]) then
			fin = string.len(valuez[i])
		end		

		show = string.sub(valuez[i], start, fin)		

		screen:print(vals[1]+2, vals[2]+6, show, fontcolor)
	end
end

function resetposition(fieldz)
	local vals = explode(fieldz, ":")
	out = vals[1]..":"..vals[2]..":"..vals[3]..":0"
	return out
end

function updatetextbox(fieldz)
	local vals = explode(fieldz, ":")
	out = textbox_x_position..":"..textbox_y_position..":"..textbox_max_chars..":"..vals[4]
	return out
end

function fieldadd(fieldz,valuez,selected,add)
	vals = explode(fieldz[selected], ":")
	if valuez[selected] then
		valuez[selected] = valuez[selected] .. add
		fieldz = shiftright(fieldz,valuez,selected)
		return valuez
	end
end

function fieldrem(fieldz,valuez,selected)
	if valuez[selected] then
		valuez[selected] = string.sub(valuez[selected], 0, string.len(valuez[selected])-1)
		fieldz = shiftleft(fieldz,valuez,selected)
		return valuez
	end
end

function shiftleft(fieldz,valuez,selected)
	local vals = explode(fieldz[selected], ":")
	local new_start = tonumber(vals[4]) - 1
	if new_start >= 0 then
		fieldz[selected] = vals[1]..":"..vals[2]..":"..vals[3]..":"..new_start
	end
	return fieldz
end

function shiftright(fieldz,valuez,selected)
	local vals = explode(fieldz[selected], ":")
	local max = vals[3]
	local start = vals[4]
	local new_start = start + 1
	if string.len(valuez[selected]) >= tonumber(vals[3]) then
		if new_start + max <= string.len(valuez[selected]) + 1 then
			fieldz[selected] = vals[1]..":"..vals[2]..":"..vals[3]..":"..new_start
		end
	end
	return fieldz
end


function showLetters(x,y,charset_in,case)
	for i = 1, 36 do
		if case == 1 then
			charset_in[i] = string.upper(charset_in[i])
		else
			charset_in[i] = string.lower(charset_in[i])
		end
	end

	--TopLeft
		screen:print(x,y+00, " "..charset_in[1], keypad_letter_color)
		screen:print(x,y+10, charset_in[2].." "..charset_in[4], keypad_letter_color)
		screen:print(x,y+20, " "..charset_in[3], keypad_letter_color)
	--TopMiddle
		screen:print(x+35,y+00, " "..charset_in[5], keypad_letter_color)
		screen:print(x+35,y+10, charset_in[6].." "..charset_in[8], keypad_letter_color)
		screen:print(x+35,y+20, " "..charset_in[7], keypad_letter_color)
	--TopRight
		screen:print(x+70,y+00, " "..charset_in[9], keypad_letter_color)
		screen:print(x+70,y+10, charset_in[10].." "..charset_in[12], keypad_letter_color)
		screen:print(x+70,y+20, " "..charset_in[11], keypad_letter_color)
	--MiddleLeft
		screen:print(x,y+35+00, " "..charset_in[13], keypad_letter_color)
		screen:print(x,y+35+10, charset_in[14].." "..charset_in[16], keypad_letter_color)
		screen:print(x,y+35+20, " "..charset_in[15], keypad_letter_color)
	--MiddleMiddle
		screen:print(x+35,y+35+00, " "..charset_in[17], keypad_letter_color)
		screen:print(x+35,y+35+10, charset_in[18].." "..charset_in[20], keypad_letter_color)
		screen:print(x+35,y+35+20, " "..charset_in[19], keypad_letter_color)
	--MiddleRight
		screen:print(x+70,y+35+00, " "..charset_in[21], keypad_letter_color)
		screen:print(x+70,y+35+10, charset_in[22].." "..charset_in[24], keypad_letter_color)
		screen:print(x+70,y+35+20, " "..charset_in[23], keypad_letter_color)
	--BottomLeft
		screen:print(x,y+70+00, " "..charset_in[25], keypad_letter_color)
		screen:print(x,y+70+10, charset_in[26].." "..charset_in[28], keypad_letter_color)
		screen:print(x,y+70+20, " "..charset_in[27], keypad_letter_color)
	--BottomMiddle
		screen:print(x+35,y+70+00, " "..charset_in[29], keypad_letter_color)
		screen:print(x+35,y+70+10, charset_in[30].." "..charset_in[32], keypad_letter_color)
		screen:print(x+35,y+70+20, " "..charset_in[31], keypad_letter_color)
	--BottomRight
		screen:print(x+70,y+70+00, " "..charset_in[33], keypad_letter_color)
		screen:print(x+70,y+70+10, charset_in[34].." "..charset_in[36], keypad_letter_color)
		screen:print(x+70,y+70+20, " "..charset_in[35], keypad_letter_color)
end

setPrefs()
setSkin(default_skin)
mp3_files = getMusic()

Wlan.init()
connections = Wlan.getConnectionConfigs()

wlan_sel = 1
while true do
	screen:clear(background_color)
	controls = Controls.read()
	if controls:start() then System.Quit() end

	while not Wlan.getSwitchState() do
		screen:clear(background_color)
		screen:print(140, 131, "Turn your WLAN switch on!", main_font_color)
		screen:flip()	
	end

	screen:print(20, 260, "R+Start to exit", main_font_color)
	screen:print(20, 20, "Please select a wireless connection:", main_font_color)

	for i = 1, #connections do
		if i == wlan_sel then
			screen:print(20, 30+(line_inc*i)+2, i.." : "..connections[i], main_selected_color)
		else
			screen:print(20, 30+(line_inc*i)+2, i.." : "..connections[i], main_font_color)
		end
	end

	if controls:down() then
		if wlan_sel + 1 <= #connections then
			wlan_sel = wlan_sel + 1
		end
		System.sleep(50)
	end

	if controls:up() then
		if wlan_sel - 1 >= 1 then
			wlan_sel = wlan_sel - 1
		end
		System.sleep(50)
	end

	if controls:cross() then
		screen:print(20, 20+(#connections*10)+30, "Connecting to "..connections[wlan_sel].."...", main_font_color)
		screen:flip()
		break
	end

	screen.flip()
	screen.waitVblankStart()
end

Wlan.useConnectionConfig(wlan_sel+1)

configz = {}

for line in io.lines("accounts.cfg") do
	line = string.gsub(line, "\r", "")
	table.insert(configz, line)
end

while true do
	screen:clear(background_color)

	controls = Controls.read()

	if controls:start() then
		if controls:r() then
			System.Quit()
		end
	end

	screen:print(20, 260, "R+Start to exit, R+Select to delete", main_font_color)
	screen:print(20, 20, "Please select a Bitlbee account:", main_font_color)
	screen:print(20, 30, "Press TRIANGLE to register/manage accounts", main_font_color)

	for i = 1, #configz do
		temp = explode(configz[i], ":")
		if i == act_sel then
			screen:print(20, 30+(line_inc*i)+2, i.." : "..temp[1], main_selected_color)
		else
			screen:print(20, 30+(line_inc*i)+2, i.." : "..temp[1], main_font_color)
		end
	end

	if controls:down() then
		if act_sel + 1 <= #configz then
			act_sel = act_sel + 1
		end
		System.sleep(50)
	end

	if controls:r() then
		if controls:select() then
			if #configz > 1 then
				newconfig = ""
				table.remove(configz,act_sel)
				for i=1,#configz do
					remval = explode(configz[i],":")
					newconfig = newconfig..remval[1]..":"..remval[2]..":"..remval[3]
					if i ~= #configz then
						newconfig = newconfig .. "\r\n"
					end
				end
				filerem = io.open("accounts.cfg","w")
				if filerem then
					filerem:write(newconfig)
					filerem:close()
				end
				
				System.sleep(250)
			end
		end		
	end


	if controls:triangle() then
		System.sleep(500)

		setup_fields = {}
		setup_fields = createfield(90,60,16,setup_fields,setup_values)
		setup_fields = createfield(90,80,16,setup_fields,setup_values)

		while true do
			screen:clear(background_color)
			controls = Controls.read()
		
			if setup_connecting then
				setup_input = setup_append .. setup_socket:recv()

				if string.len(setup_input) > 0 then
					if string.find(setup_input, "\r\n") then
						setup_last = string.sub(setup_input, string.len(setup_input)-2, string.len(setup_input))
						if setup_last ~= "\r\n" then
							setup_out = ""
							setup_cutoff = explode(setup_input, "\r\n")
							for i=1,#setup_cutoff-1 do
								setup_out = setup_out .. setup_cutoff[i] .. "\r\n"
							end
							setup_input = setup_out
							setup_append = setup_cutoff[#setup_cutoff]
						else
							setup_append = ""
						end
					end
				end

				if string.find(setup_input, " JOIN :&bitlbee") then
					setup_inlines = explode(setup_input, "\r\n")
					for i=1,#setup_inlines do
						setup_temput = setup_inlines[i]
						if string.find(setup_temput, " JOIN ") then
							setup_connected = true
							setup_status = "connected"
						end
					end
				end

				if setup_connected then
					if not setup_loggedin then
						if not setup_loggingin then
							setup_status = "logging into '"..login_user.."'"
							setup_socket:send("PRIVMSG &bitlbee :identify "..login_pass.."\r\n")
							setup_socket:send("PRIVMSG &bitlbee :account off\r\n")
							setup_loggingin = true
						end

						if string.find(setup_input, "Password accepted\r\n") then
							setup_status = "logged in as "..login_user
							setup_loggedin = true
						end

						if string.find(setup_input, "Incorrect password\r\n") then
							setup_status = "bad password (idle) relogin below"
							setup_connected = false
							setup_connecting = false
							setup_loggedin = false
							setup_loggingin = false
							setup_register = false
							setup_form = false
							setup_socket:close()
						end

						if string.find(setup_input, "not registered\r\n") then
							setup_status = "registering '"..login_pass.."'"
							setup_socket:send("PRIVMSG &bitlbee :register "..login_pass.."\r\n")
							setup_loggingin = false
						end

					else
						screen:print(20, 130, "==Add/Remove account==", main_font_color)
						screen:print(20, 155, "Username:", main_font_color)
						screen:print(20, 175, "Password:", main_font_color)
						screen:print(20, 195, "Type    :       (MSN,ICQ,AIM,Yahoo,Gtalk)", main_font_color)
						screen:print(20, 205, "                Press L+R to add", main_font_color)
						screen:print(20, 215, "                Press L+Start to remove*", main_font_color)
						screen:print(20, 225, "                *only account name required", main_font_color)
						if not setup_form then
							setup_fields = createfield(90,150,16,setup_fields,setup_values)
							setup_fields = createfield(90,170,16,setup_fields,setup_values)
							setup_fields = createfield(90,190,6,setup_fields,setup_values)
							setup_form = true
						end
					end

					if string.find(setup_input, "PING :") then
						setup_pong = "PONG :"..GetBetween(setup_input, ":", "\r\n").."\r\n"
						setup_socket:send(setup_pong)
					end

				end	
			end

			screen:print(20, 250, "R+start to return, R+select to add to list", main_font_color)
			screen:print(20, 20, "==Login/Register below==", main_font_color)
			screen:print(20, 40, "(unexisting accounts will be auto-registered)", main_font_color)
			screen:print(20, 65, "Username:                  Press L+R to", main_font_color)
			screen:print(20, 85, "Password:                  Login/Register", main_font_color)
			screen:print(20, 30, "Status: "..setup_status, main_font_color)

			if controls:l() then
				if charset_cur_index == 1 then
					charset_cur = charset1
					charset_cur_index = 2
				elseif charset_cur_index == 2 then
					charset_cur = charset2
					charset_cur_index = 3
				elseif charset_cur_index == 3 then
					charset_cur = charset3
					charset_cur_index = 1
				end
				if controls:start() then
					if setup_loggedin then
						setup_socket:send("PRIVMSG &bitlbee :account del "..setup_values[3].."\r\n")
						setup_status = "account "..setup_values[3].." deleted"
						System.sleep(250)	
					end
				end
			end


			if controls:down() then
				if selected+1 <= #setup_fields then
					selected = selected + 1
				else
					selected = 1
				end
			end

			if controls:up() then
				if selected-1 > 0 then
					selected = selected - 1
				else
					selected = #setup_fields
				end
			end
	
			outlet = getletter(sensitivity,charset_cur,keypad_location_x,keypad_location_y,controls)	
			hix = outlet[1]
			hiy = outlet[2]
			letter = outlet[3]

			if controls:r() then
				case = 1
				if letter then
					letter = string.upper(letter)
				end
			else	
				case = 0
			end

			if letter then
				if not held then
					if pad == 1 then
						if letter == "" then
							setup_values = fieldrem(setup_fields,setup_values,selected)
							word = string.sub(word, 0, string.len(word) - 1)
						else
							word = word .. letter
							setup_values = fieldadd(setup_fields,setup_values,selected,letter)
							letter = ""
						end
						held = true
						counter:reset(0)
						counter:start()
					end
				end
			else
				held = false
 			end

			if controls:r() then
				if controls:l() then
					if not setup_connecting then
						login_user = setup_values[1]
						login_pass = setup_values[2]

						setup_status = "connecting..."
						setup_connecting = true
 						setup_socket = Socket.connect("im.bitlbee.org", 6667)

 						while not setup_socket:isConnected() do
	 						System.sleep(100)
	 						if Controls.read():start() then break end
 						end

 						setup_socket:send("USER "..login_user.." PSPcc PSPcc:Bitlbee User\r\n")
 						setup_socket:send("NICK "..login_user.."\r\n")
					end
					if setup_loggedin then
						setup_values[5] = string.upper(setup_values[5])
						if string.find(setup_values[5],"AIM") then
							setup_type = "OSCAR"
							setup_server = " login.oscar.aol.com"
						elseif string.find(setup_values[5],"ICQ") then
							setup_type = "OSCAR"
							setup_server = " login.icq.com"
						elseif string.find(setup_values[5],"GTALK") then
							setup_type = "JABBER"
							setup_server = " talk.google.com:5223:ssl"
						else
							setup_type = string.upper(setup_values[5])
							setup_server = ""
						end

						setup_socket:send("PRIVMSG &bitlbee :account add "..setup_type.." "..setup_values[3].." "..setup_values[4]..setup_server.."\r\n")
						setup_socket:send("PRIVMSG &bitlbee :account list\r\n")
						setup_status = "account "..setup_values[3].." added"
						System.sleep(250)
					end
				end

				if controls:select() then
					if setup_loggedin then
						file = io.open("accounts.cfg", "a")
						if file then
							file:write("\r\n"..login_user..":"..login_pass..":im.bitlbee.org")
							file:close()
						end
						table.insert(configz, login_user..":"..login_pass..":im.bitlbee.org")
						setup_status = "account saved"
					else
						setup_status = "login before saving an account"
					end
				end
			end

			if keypad_show_bg ~= 0 then
				highlite(pad,377-5,170-5,blax)
			end

			highlite(pad,hix,hiy,color)
			showfields(setup_values,setup_fields,selected,white)
			showLetters(377,170,charset_cur,case)

			screen.flip()
			screen.waitVblankStart()
			if controls:r() then
				if controls:start() then
					setup_socket:send("QUIT :PSPcc\r\n")
					setup_status = "idle"
					setup_connected = false
					setup_connecting = false
					setup_loggedin = false
					setup_loggingin = false
					setup_register = false
					setup_form = false
					System.sleep(2000)
					setup_socket:close()					
					break			
				end
			end

			if controls:up() then System.sleep(150) end
			if controls:down() then System.sleep(150) end
			if controls:l() then System.sleep(150) end
			if controls:r() then System.sleep(150) end
		end
	end

	if controls:up() then
		if act_sel - 1 >= 1 then
			act_sel = act_sel - 1
		end
		System.sleep(50)
	end

	if controls:cross() then
		config = explode(configz[act_sel], ":")
		System.sleep(250)
		break
	end

	screen.flip()
	screen.waitVblankStart()
end

fields = createfield(textbox_x_position,textbox_y_position,textbox_max_chars,fields,values)

screen:clear(background_color)
screen:print(10,10,"Connecting to "..config[3]..":6667...", main_font_color)
screen:print(10,20,"Connecting as "..config[1], main_font_color)
screen:flip()

socket = Socket.connect(config[3], 6667)

while not socket:isConnected() do
	System.sleep(100)
	if Controls.read():start() then break end
end

socket:send("USER "..config[1].." PSPcc PSPcc:Bitlbee User\r\n")
socket:send("NICK "..config[1].."\r\n")

selected = 1
pad = 1

while true do
	press = false
	if background_image then
		screen.startBlit()
		screen:fastBlit(0,0,background_image)
		screen.endBlit()
	else
		screen:clear(background_color)
	end

	input = append .. socket:recv()

	if Mp3.EndOfStream() == "true" then
		nextTrack()
	end

	if string.len(input) > 0 then
		if string.find(input, "\r\n") then
			last = string.sub(input, string.len(input)-2, string.len(input))
			if last ~= "\r\n" then
				out = ""
				cutoff = explode(input, "\r\n")
				for i=1,#cutoff-1 do
					out = out .. cutoff[i] .. "\r\n"
				end
				input = out
				append = cutoff[#cutoff]
			else
				append = ""
			end
		end
	end

	if string.len(input) > 0 then
		log_input = string.gsub(input,"\r\n","")
		table.insert(log_data,log_input)
	end

	controls = Controls.read()
	hpcontrols = Hprm.read()
	currentTime = counter:time()

	if not connected then
		if string.find(input, "JOIN :&bitlbee") then
			connected = true
			status = "connected"
		end
	end

	if string.find(input, "PING :") then
		pong = "PONG :"..GetBetween(input, ":", "\r\n").."\r\n"
		socket:send(pong)
		table.insert(log_data,pong)
	end

	if connected then
		if not online then
			if not signin then
				socket:send("PRIVMSG &bitlbee :identify "..config[2].."\r\n")
				socket:send("PRIVMSG &bitlbee :account on\r\n")
				signin = true
			else
				if input then
					if string.find(input, "Logged in") then
						status = "online"
						online = true
						signin = false
					end
				end
			end
		else
			inlines = explode(input, "\r\n")
			for i=1,#inlines do
				temput = inlines[i]

				if string.find(temput, " JOIN :&bitlbee") then
					cuser = GetBetween(temput, ":", "!")
					usrlog = adduser(usrlog, cuser)
					if play_sounds > 0 then
						new_online:play()
					end
					status = cuser .. " just signed in"
				end

				if string.find(temput, " QUIT :") then
					cuser = GetBetween(temput, ":", "!")
					usronl = delfromarray(usronl,cuser)
					position = getindex(usrlog,cuser)
					if position then
						if lstsel > position then
							lstsel = lstsel - 1
						end
					end
					usrlog = deluser(usrlog,cuser)
					newmsg = delfromarray(newmsg,cuser)
				end

				if string.find(temput, "bitlbee +v",1,true) then
					cuser = GetBetween(temput.."\r\n", "+v ", "\r\n")
					usronl = addtoarray(usronl,cuser)
					usrlog = adduser(usrlog, cuser)
				end


				if string.find(temput, " -v ") then
					cuser = GetBetween(temput.."\r\n", " -v ", "\r\n")
					usronl = delfromarray(usronl,cuser)
					usrlog = adduser(usrlog, cuser)
				end

				if string.find(temput, "PRIVMSG "..config[1]) then
					user = GetBetween(temput, ":", "!")
					message = GetBetween(temput, "PRIVMSG "..config[1].." :", "\r\n")
					status = user..": "..message
					user_print = string.gsub(user_encapsulation,"$u",user)
					usrlog = adduser(usrlog, user)
					--msglog[getindex(usrlog,user)] = logs_add(usrlog,msglog,user,user_print..message)
					logs_add(usrlog,msglog,user,user_print..message)
					addtoarray(newmsg, user)
					if log_chats > 0 then
						saveChat(user..": "..message,user)
					end
					if play_sounds > 0 then
						new_message:play()
					end
				elseif string.find(temput, " NICK ") then
					former_user = GetBetween(temput, ":", "!")
					new_user = GetBetween(temput, " NICK ","\r\n")
					usrlog = changeuser(usrlog,former_user,new_user)
					usronl = changeuser(usronl,former_user,new_user)
					usrblc = changeuser(usrblc,former_user,new_user)
				end
			end
		end
	end

	if controls:select() then
		if controls:r() then
			if connected then
				socket:send("PRIVMSG &bitlbee :account off\r\n")
				socket:send("QUIT :PSPcc\r\n")
			end
			if is_playing then
				Mp3.stop()
			end
			System.Quit()
		end
	end

	if controls:l() then
		if pad == 1 then
			if charset_cur_index == 1 then
				charset_cur = charset1
				charset_cur_index = 2
			elseif charset_cur_index == 2 then
				charset_cur = charset2
				charset_cur_index = 3
			elseif charset_cur_index == 3 then
				charset_cur = charset3
				charset_cur_index = 1
			end
		end
	end

	if direction_full ~= "middlemiddle" then
		if selected == 1 then
			pad = 1
		end
	else
		if pad == 1 then
			if currentTime > key_timeout then
				pad = 0
				counter:reset(0)
				counter:start()
			end
		end
	end

	outlet = getletter(sensitivity,charset_cur,keypad_location_x,keypad_location_y,controls)	
	hix = outlet[1]
	hiy = outlet[2]
	letter = outlet[3]
	direction_full = outlet[4]

	if direction_full ~= "middlemiddle" then
		if selected == 1 then
			pad = 1
		end
	else
		if pad == 1 then
			if currentTime > key_timeout then
				pad = 0
				counter:reset(0)
				counter:start()
			end
		end
	end

	if controls:right() then
		if selected == 1 then
			fields = shiftright(fields,values,selected)
		else
			if not controls:r() then
				if #newmsg > 0 then
					lstsel = getindex(usrlog,newmsg[1])
					press = true
				end
			end
		end
	end

	if controls:left() then
		if selected == 1 then
			fields = shiftleft(fields,values,selected)
		end
	end

	if controls:r() then
		case = 1
		if letter then
			letter = string.upper(letter)
		end
	else	
		case = 0
	end

	if letter then
		if not held then
			if pad == 1 then
				if letter == "" then
					values = fieldrem(fields,values,selected)
					word = string.sub(word, 0, string.len(word) - 1)
				else
					word = word .. letter
					values = fieldadd(fields,values,selected,letter)
					letter = ""
				end
				held = true
				counter:reset(0)
				counter:start()
			end
		end
	else
		held = false
 	end
	
	if controls:start() then
		if selected == 1 then
			selected = 2
			highlite2 = true
			pad = 0
		else
			selected = 1
			highlite2 = false
			pad = 1
		end
	end

	if Hprm.remote() then
		if hpcontrols:forward() then
			nextTrack()
		elseif hpcontrols:back() then
			prevTrack()
		elseif hpcontrols:playpause() then
			Mp3.pause()
			System.sleep(150)		
		end
	end

	if controls:cross() then
		if selected == 2 then
			selected = 1
			highlite2 = false
			pad = 1
			System.sleep(250)
		end
	end

	if controls:square() then
		if selected == 2 then
			Mp3.pause()
			System.sleep(150)
		end
	end


	if controls:triangle() then
		if selected == 2 then
			stopPlay()
			System.sleep(150)
		end
	end

	if controls:down() then
		if selected == 2 then
			if not controls:r() then
				if lstsel + 1 <= #usrlog then
					lstsel = lstsel + 1
				else
					lstsel = 1
				end
			else
				if fileexists("skins/"..(skin_num+1).."/skin.cfg") then
					skin_num = skin_num + 1
					setSkin(skin_num)
					fields[1] = updatetextbox(fields[1])
				end
			end
		else
			if usrlog[lstsel] then
				if string.len(values[selected]) > 0 then
					socket:send("PRIVMSG "..usrlog[lstsel].." :"..values[selected].."\r\n")
					user_print = string.gsub(user_encapsulation,"$u",config[1])
					--msglog[lstsel] = logs_add(usrlog,msglog,usrlog[lstsel],user_print..values[selected])
					logs_add(usrlog,msglog,usrlog[lstsel],user_print..values[selected])
					fields[selected] = resetposition(fields[selected])
					if log_chats > 0 then
						saveChat(config[1]..": "..values[selected],usrlog[lstsel])
					end
					if play_sounds > 0 then
						send_message:play()
					end
					values[selected] = ""
				end
			end
		end
	end

	if controls:up() then
		if selected == 2 then
			if not controls:r() then
				if lstsel - 1 > -1 then
					lstsel = lstsel - 1
				else
					lstsel = #usrlog
				end
			else
				if fileexists("skins/"..(skin_num-1).."/skin.cfg") then
					skin_num = skin_num - 1
					setSkin(skin_num)
					fields[1] = updatetextbox(fields[1])
				end
			end
		end
	end

	if inarray(newmsg,usrlog[lstsel]) then
		delfromarray(newmsg,usrlog[lstsel])
	end

	if string.len(status) > status_max_length then
		status = string.sub(status,0,status_max_length-3).."..."
	end

	screen:print(status_location_x,status_location_y,status,main_font_color)

	if newmsg[1] then
		screen:print(new_message_alert_x,new_message_alert_y,new_message_alert_text,new_message_text)	
	end	

	showfields(values,fields,selected,textbox_font_color)

	if usrlog[lstsel] then
		msglog[lstsel] = showlog(log_x_position,log_y_position,log_max_chars,log_max_lines,msglog[lstsel],1)
	else
		log_data = showlog(log_x_position,log_y_position,log_max_chars,log_max_lines,log_data,0)
	end

	showlist(list_x_position,list_y_position,list_max_chars,list_max_lines,usrlog,lstsel,highlite2)

	if pad == 1 then
		if selected == 1 then
			if keypad_show_bg ~= 0 then
				highlite(pad,keypad_location_x-5,keypad_location_y,blk)
			end
			highlite(pad,hix,hiy,color)
			showLetters(keypad_location_x,keypad_location_y,charset_cur,case)
		end
	end

	if selected ~= 1 then
		if controls:r() then
			if controls:right() then
				nextTrack()
			elseif controls:left() then
				prevTrack()
			end
		end
		if controls:l() then
			if not instruction_shown then
				status = "input new buddy name below"
				instruction_shown = true
			end
			screen:blit(menu_location_x,menu_location_y,menu)
			screen:print(menu_location_x+8,menu_location_y+8,"T: (UN)BLOCK",action_menu_fontclr)
			screen:print(menu_location_x+8,menu_location_y+18,"S: AWAY/BACK",action_menu_fontclr)
			screen:print(menu_location_x+8,menu_location_y+28,"O: SND ON/OFF",action_menu_fontclr)
			screen:print(menu_location_x+8,menu_location_y+38,"R: RENAME",action_menu_fontclr)
			screen:print(menu_location_x+8,menu_location_y+48,"SEL: REMOVE",action_menu_fontclr)

			if controls:triangle() then
				if inarray(usrblc,usrlog[lstsel]) then
					socket:send("PRIVMSG &bitlbee :allow "..usrlog[lstsel].."\r\n")
					usrblc = delfromarray(usrblc,usrlog[lstsel])
				else
					socket:send("PRIVMSG &bitlbee :block "..usrlog[lstsel].."\r\n")
					usrblc = addtoarray(usrblc,usrlog[lstsel])
				end
				press = true
			elseif controls:square() then
				if inarray(usronl,config[1]) then
					socket:send("AWAY :AFK\r\n")
					usronl = delfromarray(usronl,config[1])
					status = "you are now set as away"
				else
					socket:send("AWAY\r\n")
					usronl = addtoarray(usronl,config[1])
					status = "you are now set as back (online)"
				end
				press = true
			elseif controls:circle() then
				if play_sounds ~= 0 then
					play_sounds = 0
					status = "sounds turned off"
				else
					play_sounds = 1
					status = "sounds turned on"
				end
				press = true
			elseif controls:select() then
				socket:send("PRIVMSG &bitlbee :remove "..usrlog[lstsel].."\r\n")
				status = "removed '"..usrlog[lstsel].."' from contacts"
				press = true
			elseif controls:r() then
				if values[1] ~= "" then
					socket:send("PRIVMSG &bitlbee :rename "..usrlog[lstsel].." "..values[1].."\r\n")
					status = "renamed '"..usrlog[lstsel].."' to '"..values[1].."'"
					values[1] = ""
					fields[1] = resetposition(fields[1])
					press = true
				else
					status = "cannot rename "..usrlog[lstsel].." to ''"
				end	
			end
		else
			if instruction_shown then
				status = "idle"
				instruction_shown = false
			end
		end
	end

	screen.flip()

	screen.waitVblankStart()

	if press then
		System.sleep(250)
	end

	if controls:l() then System.sleep(150) end
	if controls:up() then System.sleep(100) end
	if controls:down() then System.sleep(100) end
	if controls:start() then System.sleep(250) end
end